<?php
use Projectify\Projectify_Helper;

class projectifyCarouselCircle {

	public static $args;

	/**
	 * Initiate the shortcode
	 */
	public function __construct() {
		
		add_shortcode( 'pjfy_carousel_circle', array( $this, 'render' ) );

	}

	function render( $args, $content = '') {
		

		$defaults = shortcode_atts( array (
			 'post_type'  				=> 'post',
			 'post_tax'   				=> '',
			 'post_terms' 				=> '',
			 'post_number' 				=> '',
			 'post_offset' 				=> '',
			 'cc_category_show' 		=> '',
			 'cc_main_layout' 			=> '',
			 'cc_box_shadow_gamma' 		=> '',
			 'cc_box_shadow_numbered' 	=> '',
			 'cc_box_shadow_numbered2'	=> '',
			 'cc_beta_bg_line'		 	=> '',
			 'cc_numbered_img_thumb'	=> '',
			 'cc_numbered_hover_thumb'	=> '',
			 'pjfy_lightbox'			=> '',
			 'fn_page_include'			=> '',
			 'included_posts'			=> '',
		), $args );
		
		extract( $defaults );

		self::$args = $defaults;

		$fn_post_offset 			= $args['post_offset'];
		
		$query_args = array(
			'post_type' 			=> $args['post_type'],
			'offset' 				=> $fn_post_offset,
			'posts_per_page' 		=> $args['post_number'],
			'post_status' 			=> 'publish',
			'order' 				=> $args['post_order'],
			'orderby' 				=> $args['post_orderby'],
		);
		
		if($included_posts != ''){
			$included_posts = explode( ',', $included_posts );
		}else{
			$included_posts = array();
		}
		$query_args['post__in'] 	= $included_posts;

		$post_type 			= $args['post_type'];
		$fn_page_include 	= $args['fn_page_include'];
		if($post_type == 'page'){
			if($fn_page_include == 'featured_pages'){
				$query_args['meta_query'][] = array(
					'key'       => 'pjfy-meta-box-featured',
					'value'     => 'true',
					'compare'   => '==',
				);
			}
		}
			
		
		$categories = $args['post_terms'];
		
		// since v2.3
		if($categories != ''){
			$categories = explode( ',', $categories );
			$oldArray	= array();
			$count		= 0;
			$newArray	= array();
			foreach($categories as $cat){
				if (strpos($cat, '______') !== false) {
					$cat = explode('______', $cat);
					if(array_key_exists($cat[1],$newArray)){
						array_push($newArray[$cat[1]],$cat[0]);
					}else{
						$newArray[$cat[1]] = array($cat[0]);
					}
				}else{
					$oldArray[] = $cat;
				}
			}
			if(!empty($newArray)){
				foreach($newArray as $taxonomy => $terms){
					$count++;
					if($count > 1){
						$query_args['tax_query']['relation'] = 'OR';
					}
					$query_args['tax_query'] = array(
						array(
							'taxonomy' 	=> $taxonomy,
							'field' 	=> 'slug',
							'terms' 	=> $terms
						)
					);
				}
			}
			if(!empty($oldArray)){
				if($count > 1){
					$query_args['tax_query']['relation'] = 'OR';
				}
				$query_args['tax_query'] = array(
					array(
						'taxonomy' 	=> $args['post_tax'],
						'field' 	=> 'slug',
						'terms' 	=> $oldArray
					)
				);
			}	
		}
		
		$projectify_post_loop = new WP_Query($query_args);
		
		// FOR ALL VERSIONS
		$html = Projectify_Helper::projectify_open_wrap();
		$html .= '<div class="circle_carousel_version"><div class="projectify_carousel_circle '.$args['cc_main_layout'].'" data-category-show="'.$args['cc_category_show'].'" data-box-shadow-gamma="'.$args['cc_box_shadow_gamma'].'" data-box-shadow-numbered="'.$args['cc_box_shadow_numbered'].'" data-box-shadow-numbered2="'.$args['cc_box_shadow_numbered2'].'" data-bg-line="'.$args['cc_beta_bg_line'].'" data-numbered-img-thumb="'.$args['cc_numbered_img_thumb'].'" data-numbered-hover-thumb="'.$args['cc_numbered_hover_thumb'].'">';
		
		
		$img_slider = $content_controller = $content_slider = '';
		$arrow 		= '<span class="a"></span><span class="b"></span>';
		$fn_prev 	= '<div class="fn_prev">'.$arrow.'</div>';
		$fn_next 	= '<div class="fn_next">'.$arrow.'</div>';
		$real_img	= '<img src="'.PROJECTIFY_PLUGIN_URL.'assets/img/thumb-square.jpg" alt="" />';
		
		if($pjfy_lightbox === 'enable'){
			$parentLight = 'projectify_fn_lightbox';
			$childLight	 = 'lightbox';
		}else{
			$parentLight = '';
			$childLight	 = '';
		}
		
		if($args['cc_main_layout'] === 'alpha'){
			
			// ALPHA VERSION
			$img_slider	.= '<div class="img-slider '.$parentLight.'"><div class="swiper-wrapper">';
			$content_controller .= '<div class="alpha_controller">'.$fn_prev.$fn_next.'</div>';
			$content_slider .= '<div class="content-slider">'.$content_controller.'<div class="swiper-wrapper">';
			
		}else if($args['cc_main_layout'] === 'beta'){
			
			// BETA VERSION
			$content_controller .= '<div class="beta_controller">'.$fn_prev.$fn_next.'</div>';
			$img_slider	.= '<div class="img_slider_wrap '.$parentLight.'"><div class="inner"><div class="img-slider">'.$content_controller.'<div class="swiper-wrapper">';
			$content_slider .= '<div class="content-slider"><div class="swiper-wrapper">';
			
		}else if($args['cc_main_layout'] === 'gamma'){
			
			// GAMMA VERSION
			$content_controller .= '<div class="gamma_controller">'.$fn_prev.$fn_next.'</div>';
			$img_slider	.= '<div class="img-slider '.$parentLight.'">'.$content_controller.'<div class="swiper-wrapper">';
			$content_slider .= '<div class="content-slider"><div class="swiper-wrapper">';
			
		}else if($args['cc_main_layout'] === 'numbered'){
			
			// NUMBERED VERSION
			$content_controller .= '<div class="numbered_controller">'.$fn_prev.$fn_next.'</div>';
			$img_slider	.= '<div class="img_slider_wrap '.$parentLight.'"><div class="img-slider"><div class="img_slider_in">'.$content_controller.'<div class="swiper-wrapper">';
			$content_slider .= '<div class="content-slider"><div class="swiper-wrapper">';
			
		}else if($args['cc_main_layout'] === 'numbered2'){
			
			// NUMBERED2 VERSION
			$content_controller .= '<div class="numbered_controller">'.$fn_prev.$fn_next.'</div>';
			$img_slider	.= '<div class="img_slider_wrap '.$parentLight.'"><div class="img-slider"><div class="img_slider_in">'.$content_controller.'<div class="swiper-wrapper">';
			$content_slider .= '<div class="content-slider"><div class="swiper-wrapper">';
			
		}
		
		
		
		
		
		
		// foreach
		foreach ( $projectify_post_loop->posts as $key => $fn_post ) {
			setup_postdata( $fn_post );
			$post_id 			= $fn_post->ID;
			$post_permalink 	= get_permalink($post_id);
			$post_taxonomy		= Projectify_Helper::post_taxanomy($args['post_type']);
			$post_cats			= '';
			if($args['post_type'] != 'page'){
				$post_cats			= Projectify_Helper::post_term_list($post_id, $post_taxonomy[0], false, 2, ', ');
			}
			
			$image 			= get_the_post_thumbnail_url( $post_id, 'full' );
			
			$image_holder		= '<div class="img_holder" data-bg-img="'.$image.'"></div>';
			$title_holder		= '<div class="title_holder"><p><span>'.$post_cats.'</span></p><h3><a href="'.$post_permalink.'">'.$fn_post->post_title.'</a></h3></div>';
			
			if($pjfy_lightbox === 'enable'){
				$imageURLThumb 	= get_the_post_thumbnail_url( $post_id, 'thumbnail' );
				$lightboxImg	= '<img class="pjfy_light_img" src="'.$imageURLThumb.'" alt="" />';
			}else{
				$lightboxImg 	= '';
				$imageURLThumb 	= '';
			}
			
			$count = $key+1;
			if($count < 10){
				$count2 = '0'.$count;
			}else{
				$count2 = $count;
			}
			$spanCount = '<span class="count">'.$count2.'</span>';
			
			if($args['cc_main_layout'] === 'alpha'){
				
				$content_slider .= '<div class="swiper-slide">'.$title_holder.'</div>';
				$img_slider .= '<div class="swiper-slide"><div class="item_holder '.$childLight.'" data-src="'.$image.'">'.$lightboxImg.'<div class="item">'.$image_holder.'</div></div></div>';
				
			}else if($args['cc_main_layout'] === 'beta'){
				
				$content_slider .= '<div class="swiper-slide">'.$title_holder.'</div>';
				$img_slider .= '<div class="swiper-slide"><div class="item_holder '.$childLight.'" data-src="'.$image.'">'.$lightboxImg.'<div class="item">'.$real_img.$image_holder.'</div></div></div>';
				
			}else if($args['cc_main_layout'] === 'gamma'){
				
				$content_slider .= '<div class="swiper-slide">'.$title_holder.'</div>';
				$img_slider .= '<div class="swiper-slide"><div class="item_holder '.$childLight.'" data-src="'.$image.'">'.$lightboxImg.'<div class="item">'.$image_holder.'</div></div></div>';
			}else if($args['cc_main_layout'] === 'numbered'){
				
				$content_slider .= '<div class="swiper-slide">'.$title_holder.'</div>';
				$img_slider .= '<div class="swiper-slide">'.$real_img.'<div class="item_holder '.$childLight.'" data-src="'.$image.'">'.$lightboxImg.'<div class="item">'.$image_holder.$spanCount.'</div></div></div>';
				
			}else if($args['cc_main_layout'] === 'numbered2'){
				
				$content_slider .= '<div class="swiper-slide">'.$title_holder.'</div>';
				$img_slider .= '<div class="swiper-slide">'.$real_img.'<div class="item_holder '.$childLight.'" data-src="'.$image.'">'.$lightboxImg.'<div class="item">'.$image_holder.$spanCount.'</div></div></div>';
				
			}
			
			wp_reset_postdata();
		}
		if($args['cc_main_layout'] === 'alpha'){
			$img_slider .= '</div></div>';
			$content_slider .= '</div></div>';
		}else if($args['cc_main_layout'] === 'beta'){
			$img_slider .= '</div></div></div></div>';
			$content_slider .= '</div></div>';
		}else if($args['cc_main_layout'] === 'gamma'){
			$img_slider .= '</div></div>';
			$content_slider .= '</div></div>';
		}else if($args['cc_main_layout'] === 'numbered'){
			$img_slider .= '</div></div></div></div>';
			$content_slider .= '</div></div>';
		}else if($args['cc_main_layout'] === 'numbered2'){
			$img_slider .= '</div></div></div></div>';
			$content_slider .= '</div></div>';
		}
		
		$html .= $img_slider.$content_slider;
		$html .= '</div></div>';
		$html .= Projectify_Helper::projectify_close_wrap();

		return $html;

	}
	

}

new projectifyCarouselCircle();