<?php
use Projectify\Projectify_Helper;

class projectifyCarouselWithContent {

	public static $args;

	/**
	 * Initiate the shortcode
	 */
	public function __construct() {
		
		add_shortcode( 'pjfy_carousel_with_content', array( $this, 'render' ) );

	}

	function render( $args, $content = '') {
		

		$defaults = shortcode_atts( array (
			 'post_type'  				=> 'post',
			 'post_tax'   				=> '',
			 'post_terms' 				=> '',
			 'post_number' 				=> '',
			 'post_number' 				=> '',
			 'cwc_category_show' 		=> '',
			 'cwc_main_layout' 			=> '',
			 'cwc_img_ratio' 			=> '',
			 'cwc_fslide_title' 		=> '',
			 'cwc_fslide_desc' 			=> '',
			 'cwc_fslide_sign' 			=> '',
			 'cwc_alpha_bg_type' 		=> '',
			 'pjfy_lightbox'			=> '',
			 'fn_page_include'			=> '',
			 'included_posts'			=> '',
		), $args );
		
		extract( $defaults );

		self::$args = $defaults;

		$fn_post_offset 			= $args['post_offset'];
		
		$query_args = array(
			'post_type' 			=> $args['post_type'],
			'offset' 				=> $fn_post_offset,
			'posts_per_page' 		=> $args['post_number'],
			'post_status' 			=> 'publish',
			'order' 				=> $args['post_order'],
			'orderby' 				=> $args['post_orderby'],
		);
		
		if($included_posts != ''){
			$included_posts = explode( ',', $included_posts );
		}else{
			$included_posts = array();
		}
		$query_args['post__in'] 	= $included_posts;
		
		$post_type 			= $args['post_type'];
		$fn_page_include 	= $args['fn_page_include'];
		if($post_type == 'page'){
			if($fn_page_include == 'featured_pages'){
				$query_args['meta_query'][] = array(
					'key'       => 'pjfy-meta-box-featured',
					'value'     => 'true',
					'compare'   => '==',
				);
			}
		}
			
		
		$categories = $args['post_terms'];
		
		// since v2.3
		if($categories != ''){
			$categories = explode( ',', $categories );
			$oldArray	= array();
			$count		= 0;
			$newArray	= array();
			foreach($categories as $cat){
				if (strpos($cat, '______') !== false) {
					$cat = explode('______', $cat);
					if(array_key_exists($cat[1],$newArray)){
						array_push($newArray[$cat[1]],$cat[0]);
					}else{
						$newArray[$cat[1]] = array($cat[0]);
					}
				}else{
					$oldArray[] = $cat;
				}
			}
			if(!empty($newArray)){
				foreach($newArray as $taxonomy => $terms){
					$count++;
					if($count > 1){
						$query_args['tax_query']['relation'] = 'OR';
					}
					$query_args['tax_query'] = array(
						array(
							'taxonomy' 	=> $taxonomy,
							'field' 	=> 'slug',
							'terms' 	=> $terms
						)
					);
				}
			}
			if(!empty($oldArray)){
				if($count > 1){
					$query_args['tax_query']['relation'] = 'OR';
				}
				$query_args['tax_query'] = array(
					array(
						'taxonomy' 	=> $args['post_tax'],
						'field' 	=> 'slug',
						'terms' 	=> $oldArray
					)
				);
			}	
		}
		
		
		$projectify_post_loop	= new WP_Query($query_args);
		
		if($pjfy_lightbox === 'enable'){
			$parentLight = 'projectify_fn_lightbox';
			$childLight	 = 'lightbox';
		}else{
			$parentLight = '';
			$childLight	 = '';
		}
		
		// FOR ALL VERSIONS
		$html = Projectify_Helper::projectify_open_wrap();
		$html .= '<div class="with_content_carousel_version"><div class="projectify_carousel_with_content '.$parentLight.' '.$args['cwc_main_layout'].'" data-category-show="'.$args['cwc_category_show'].'" data-alpha-bg-type="'.$args['cwc_alpha_bg_type'].'">';
		
		
		$img_slider = $content_controller = '';
		$arrow 		= '<span class="a"></span><span class="b"></span>';
		$fn_prev 	= '<div class="fn_prev">'.$arrow.'</div>';
		$fn_next 	= '<div class="fn_next">'.$arrow.'</div>';
		$real_img	= '<img src="'.PROJECTIFY_PLUGIN_URL.'assets/img/thumb-'.$args['cwc_img_ratio'].'.jpg" alt="" />';
		$real_img2	= '<img src="'.PROJECTIFY_PLUGIN_URL.'assets/img/thumb-square.jpg" alt="" />';
		
		
			
		// ALPHA VERSION
		$content_controller .= '<div class="alpha_controller">'.$fn_prev.$fn_next.'</div>';
		$img_slider	.= '<div class="img-slider">'.$content_controller.'<div class="swiper-wrapper">';
		
		// FIRST SLIDE
		$fslideTitle		= '<h3>'.$args['cwc_fslide_title'].'</h3>';
		$fslideDesc			= '<p>'.$args['cwc_fslide_desc'].'</p>';
		$fslideSign			= '<img class="fn_sign" src="'.$args['cwc_fslide_sign'].'" alt="" />';
		$content_holder		= '<div class="desc_wrap"><div class="desc_holder"><div class="description">'.$fslideTitle.$fslideDesc.$fslideSign.'</div></div></div>';
		$first_slide		= '<div class="swiper-slide fn-swiper-slides fn-width-auto fn-first-slide"><div class="item_wrap"><div class="item_holder"><div class="item"><div class="img_holder">'.$real_img2.'</div>'.$content_holder.'</div></div></div></div>';
		
		$img_slider 		.= $first_slide;
		
		// foreach
		foreach ( $projectify_post_loop->posts as $key => $fn_post ) {
			setup_postdata( $fn_post );
			$post_id 			= $fn_post->ID;
			$post_permalink 	= get_permalink($post_id);
			$post_taxonomy		= Projectify_Helper::post_taxanomy($args['post_type']);
			$post_cats			= '';
			if($args['post_type'] != 'page'){
				$post_cats			= Projectify_Helper::post_term_list($post_id, $post_taxonomy[0], false, 2, ', ');
			}
			
			$image 				= get_the_post_thumbnail_url( $post_id, 'full' );
			
			if($pjfy_lightbox === 'enable'){
				$imageURLThumb 	= get_the_post_thumbnail_url( $post_id, 'thumbnail' );
				$lightboxImg	= '<img class="pjfy_light_img" src="'.$imageURLThumb.'" alt="" />';
			}else{
				$lightboxImg 	= '';
				$imageURLThumb 	= '';
			}
			
			$image_holder		= '<div class="abs_img" data-bg-img="'.$image.'"></div>';
			if($args['cwc_main_layout'] === 'beta'){
				$title_holder		= '<div class="beta_title_holder"><h3><a href="'.$post_permalink.'">'.$fn_post->post_title.'</a></h3><p><span>'.$post_cats.'</span></p></div>';
			}else{
				$title_holder		= '<div class="title_holder"><p><span>'.$post_cats.'</span></p><h3><a href="'.$post_permalink.'">'.$fn_post->post_title.'</a></h3></div>';
			}
			
			
			$img_slider .= '<div class="swiper-slide fn-width-auto fn-swiper-slides fn-sample-slides"><div class="item_wrap"><div class="item_holder"><div class="item '.$childLight.'" data-src="'.$image.'">'.$lightboxImg.'<div class="img_holder">'.$real_img.$image_holder.'</div>'.$title_holder.'</div></div></div></div>';

			
			wp_reset_postdata();
		}
		
		$img_slider .= '<div class="swiper-slide fn-width-auto fn-swiper-slides fn-last-slide"></div>';
		$img_slider .= '</div></div>';
		
		
		$html .= $img_slider;
		$html .= '</div></div>';
		$html .= Projectify_Helper::projectify_close_wrap();

		return $html;

	}
	

}

new projectifyCarouselWithContent();